;---------------------------------
; EMM の中身をV-RAMにひたすら転送
;
; I/OデータのPIO-3034 320K EMM は I/Oアドレス 00～03 で 320KB。DIP SW でベースアドレスは変更可能らしい。
; Unicard mk3b はramdisk.cfg で 最大16MBまで。
;RD mode:
;=========
;-W 0xE9 - set bank (0x00-0xFF) for MZ-700 or MZ-800 (not for MZ-1500!)
;RW 0xEA - I/O data, addr++
;-W 0xEB - set addr, Data(D0-7) = LoBYTE, Addr(8-15) = HiBYTE (on Unicard LoBYTE only)
;R- 0xF8 - reset addr and page
;-W 0xF8 - set HiBYTE addr
;
;SROM/SRAM mode:
;================
;R- 0xF8/0xA8 - reset addr
;R- 0xF9/0xA9 - read data, addr++
;-W 0xFA      - write data, addr++
;
; Unicard mk3b はemm.cfg で PIO-3034 と互換。640KB固定？
; EmuZ-700/800/1500は最大16MBまで、I/Oアドレス 00～03 。
; 16MB = $100000
;
;
;	アドレス系定数
;
Virtual_VRAM	EQU		$2000
;
;	I/Oアドレス定数
;
EMM_AD		EQU	$00		; PIO-3034

;
	ORG		$1200
;
	DI
	LD		DE,$0000	; EMM上のアドレス(24bit中、上位16bit)
;
	;	どうせこのプログラムしかアクセスしないんだからアドレスセットするのは最初の1回だけでいいんじゃね？と割り切って先頭でアドレスセットするだけ。以後はオートインクリメントに任せる
	LD		BC,EMM_AD			; B は 0 でいいので
	OUT		(C),B				; アドレスカウンタのBit7-0は 0 でいい。
	INC		C
	OUT		(C),E				; アドレスカウンタ Bit15-8
	INC		C
	OUT		(C),D				; アドレスカウンタ Bit23-16
;
MAIN_LOOP:
	LD		HL,Virtual_VRAM		; バッファアドレス
	CALL	READ_EMM_PIO3034_2K	; 合計 2048 Byte 読み込む
	LD		A,D
	OR		E
	JP		Z,EXIT
;
; 画面に表示
;
	PUSH	DE
; 紅茶羊羹さんの転送ルーチン
	LD		HL,Virtual_VRAM		; バッファアドレス
	LD		( L1 + 1 ),HL
	LD		BC,1000				; 2048 バイトよむけど、先頭1000がテキスト、次の1000がアトリビュート。48バイトムダだけど気にしない。
	ADD		HL,BC
	LD		( L2 + 1 ),HL
	CALL	VRAMTRANS
;
	POP		DE
	JP	MAIN_LOOP
;
EXIT:
	JP		$004A				; モニタの初期化から、に戻る
;	JP		$00AD
;
READ_EMM_PIO3034_2K:
	LD		BC,EMM_AD + 3		; B は 0 でいいので
;1
	INIR							; 読んで(HL)に書いてHL++ を 256回
	;
	INC		DE					; DE は勝手にインクリメントされないので。
;2
	INIR							; 読んで(HL)に書いてHL++ を 256回
	;
	INC		DE					; DE は勝手にインクリメントされないので。
;3
	INIR							; 読んで(HL)に書いてHL++ を 256回
	;
	INC		DE					; DE は勝手にインクリメントされないので。
;4
	INIR							; 読んで(HL)に書いてHL++ を 256回
	;
	INC		DE					; DE は勝手にインクリメントされないので。
;5
	INIR							; 読んで(HL)に書いてHL++ を 256回
	;
	INC		DE					; DE は勝手にインクリメントされないので。
;6
	INIR							; 読んで(HL)に書いてHL++ を 256回
	;
	INC		DE					; DE は勝手にインクリメントされないので。
;7
	INIR							; 読んで(HL)に書いてHL++ を 256回
	;
	INC		DE					; DE は勝手にインクリメントされないので。
;8
	INIR							; 読んで(HL)に書いてHL++ を 256回
	;
	INC		DE					; DE は勝手にインクリメントされないので。
;
	RET
;
INCLUDE "youkanVRAM.asm"
;
	END
